> ## Documentation Index
> Fetch the complete documentation index at: https://apidocs.specurate.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Validate



## OpenAPI

````yaml /openapi.json post /v1/workspaces/{workspaceId}/assistant/conversations/{conversationId}/messages/{messageId}/report-drafts/{draftId}/validate-selection
openapi: 3.1.0
info:
  title: Specurate API
  description: ''
  version: 1.0.0
  contact: {}
servers:
  - url: https://app.specurate.com/api
    description: API Server
security: []
tags: []
paths:
  /v1/workspaces/{workspaceId}/assistant/conversations/{conversationId}/messages/{messageId}/report-drafts/{draftId}/validate-selection:
    post:
      tags:
        - Assistant Report Draft Reviews
      summary: Validate
      operationId: AssistantReportDraftReviewsController_validate_v1
      parameters:
        - name: workspaceId
          required: true
          in: path
          schema:
            type: string
            pattern: ^[1-9]\d*$
        - name: conversationId
          required: true
          in: path
          schema:
            type: string
            pattern: ^[1-9]\d*$
        - name: messageId
          required: true
          in: path
          schema:
            type: string
            pattern: ^[1-9]\d*$
        - name: draftId
          required: true
          in: path
          schema:
            type: string
            minLength: 1
            maxLength: 200
      requestBody:
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/AssistantReportDraftSelectionBodyDto'
      responses:
        '200':
          description: ''
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/AssistantReportDraftSelectionResponseDto'
components:
  schemas:
    AssistantReportDraftSelectionBodyDto:
      type: object
      properties:
        projectId:
          anyOf:
            - type: string
              pattern: ^[1-9]\d*$
            - type: 'null'
        templateId:
          type: string
          pattern: ^[1-9]\d*$
        baseVersion:
          type: integer
          exclusiveMinimum: 0
          maximum: 9007199254740991
        baseWorkingCopyRevision:
          anyOf:
            - type: string
              minLength: 1
              maxLength: 100
            - type: 'null'
        contractVersion:
          type: integer
          exclusiveMinimum: 0
          maximum: 9007199254740991
        fingerprint:
          type: string
          pattern: ^[a-f0-9]{64}$
        decisions:
          maxItems: 20
          type: array
          items:
            type: object
            properties:
              groupId:
                type: string
                minLength: 1
                maxLength: 100
              choice:
                type: string
                enum:
                  - keep
                  - skip
              editedValue:
                anyOf:
                  - type: string
                    maxLength: 32768
                  - type: number
                  - type: boolean
                  - type: 'null'
                  - type: object
                    properties:
                      top:
                        type: number
                        minimum: 5
                        maximum: 50
                        multipleOf: 0.5
                      right:
                        type: number
                        minimum: 5
                        maximum: 50
                        multipleOf: 0.5
                      bottom:
                        type: number
                        minimum: 5
                        maximum: 50
                        multipleOf: 0.5
                      left:
                        type: number
                        minimum: 5
                        maximum: 50
                        multipleOf: 0.5
                    required:
                      - top
                      - right
                      - bottom
                      - left
                    additionalProperties: false
                  - maxItems: 40
                    type: array
                    items:
                      type: string
                      minLength: 1
                      maxLength: 120
            required:
              - groupId
              - choice
            additionalProperties: false
      required:
        - projectId
        - templateId
        - baseVersion
        - baseWorkingCopyRevision
        - contractVersion
        - fingerprint
        - decisions
      additionalProperties: false
    AssistantReportDraftSelectionResponseDto:
      oneOf:
        - type: object
          properties:
            status:
              type: string
              enum:
                - valid
            fence:
              type: object
              properties:
                contractVersion:
                  type: number
                  enum:
                    - 1
                templateId:
                  type: string
                  pattern: ^[1-9]\d*$
                baseVersion:
                  type: integer
                  exclusiveMinimum: 0
                  maximum: 9007199254740991
                baseWorkingCopyRevision:
                  type:
                    - string
                    - 'null'
                fingerprint:
                  type: string
                  pattern: ^[a-f0-9]{64}$
              required:
                - contractVersion
                - templateId
                - baseVersion
                - baseWorkingCopyRevision
                - fingerprint
              additionalProperties: false
            delta:
              type: object
              properties:
                customFields:
                  type: array
                  items:
                    type: object
                    properties:
                      id:
                        type: string
                        pattern: ^[A-Za-z0-9_-]{1,64}$
                      token:
                        type: string
                        pattern: ^[A-Za-z0-9_-]+$
                      label:
                        type: string
                        minLength: 1
                        maxLength: 255
                    required:
                      - id
                      - token
                      - label
                    additionalProperties: false
                page:
                  type: object
                  properties:
                    size:
                      type: string
                      enum:
                        - A4
                        - A3
                        - letter
                    orientation:
                      type: string
                      enum:
                        - portrait
                        - landscape
                    margin:
                      type: string
                      enum:
                        - compact
                        - standard
                        - generous
                    margins:
                      anyOf:
                        - type: object
                          properties:
                            top:
                              type: number
                              minimum: 5
                              maximum: 50
                              multipleOf: 0.5
                            right:
                              type: number
                              minimum: 5
                              maximum: 50
                              multipleOf: 0.5
                            bottom:
                              type: number
                              minimum: 5
                              maximum: 50
                              multipleOf: 0.5
                            left:
                              type: number
                              minimum: 5
                              maximum: 50
                              multipleOf: 0.5
                          required:
                            - top
                            - right
                            - bottom
                            - left
                          additionalProperties: false
                        - type: 'null'
                  additionalProperties: false
                showCover:
                  type: boolean
                showIndex:
                  type: boolean
                showDisclaimer:
                  type:
                    - boolean
                    - 'null'
                showHeader:
                  type: boolean
                showFooter:
                  type: boolean
                density:
                  type: string
                  enum:
                    - compact
                    - comfortable
                showChangeSummary:
                  type: boolean
                blockGap:
                  anyOf:
                    - type: number
                      minimum: 0
                      maximum: 12
                    - type: 'null'
                groupBy:
                  anyOf:
                    - type: string
                      enum:
                        - none
                        - category
                        - subcategory
                        - area
                        - manufacturer
                        - supplier
                        - department
                    - type: 'null'
                blocks:
                  maxItems: 80
                  type: array
                  items:
                    anyOf:
                      - oneOf:
                          - type: object
                            properties:
                              id:
                                type: string
                                minLength: 1
                                maxLength: 120
                              type:
                                type: string
                                enum:
                                  - heading
                              props:
                                type: object
                                properties:
                                  text:
                                    type: string
                                    maxLength: 500
                                  level:
                                    type: string
                                    enum:
                                      - '1'
                                      - '2'
                                      - '3'
                                  align:
                                    type: string
                                    enum:
                                      - left
                                      - center
                                      - right
                                  size:
                                    default: null
                                    anyOf:
                                      - type: number
                                        minimum: 0.5
                                        maximum: 3
                                      - type: 'null'
                                  weight:
                                    default: null
                                    anyOf:
                                      - type: string
                                        enum:
                                          - regular
                                          - medium
                                          - bold
                                      - type: 'null'
                                  textTransform:
                                    type: string
                                    enum:
                                      - none
                                      - uppercase
                                      - title
                                      - sentence
                                      - brand
                                  background:
                                    anyOf:
                                      - type: string
                                        enum:
                                          - none
                                          - primary
                                          - secondary
                                      - type: string
                                        pattern: ^#[0-9A-F]{6}$
                                  repeatEveryPage:
                                    type: boolean
                                  repeatWhileSectionContinues:
                                    type: boolean
                                required:
                                  - text
                                  - level
                                  - align
                                  - size
                                  - weight
                                additionalProperties: false
                            required:
                              - id
                              - type
                              - props
                            additionalProperties: false
                          - type: object
                            properties:
                              id:
                                type: string
                                minLength: 1
                                maxLength: 120
                              type:
                                type: string
                                enum:
                                  - text
                              props:
                                type: object
                                properties:
                                  text:
                                    type: string
                                    maxLength: 8000
                                  align:
                                    default: left
                                    type: string
                                    enum:
                                      - left
                                      - center
                                      - right
                                  size:
                                    default: null
                                    anyOf:
                                      - type: number
                                        minimum: 0.5
                                        maximum: 3
                                      - type: 'null'
                                  weight:
                                    default: null
                                    anyOf:
                                      - type: string
                                        enum:
                                          - regular
                                          - medium
                                          - bold
                                      - type: 'null'
                                  textTransform:
                                    type: string
                                    enum:
                                      - none
                                      - uppercase
                                      - title
                                      - sentence
                                      - brand
                                  background:
                                    anyOf:
                                      - type: string
                                        enum:
                                          - none
                                          - primary
                                          - secondary
                                      - type: string
                                        pattern: ^#[0-9A-F]{6}$
                                  repeatEveryPage:
                                    type: boolean
                                required:
                                  - text
                                  - align
                                  - size
                                  - weight
                                additionalProperties: false
                            required:
                              - id
                              - type
                              - props
                            additionalProperties: false
                          - type: object
                            properties:
                              id:
                                type: string
                                minLength: 1
                                maxLength: 120
                              type:
                                type: string
                                enum:
                                  - fieldList
                              props:
                                type: object
                                properties:
                                  labelTransform:
                                    type: string
                                    enum:
                                      - none
                                      - uppercase
                                      - title
                                      - sentence
                                      - brand
                                  fields:
                                    maxItems: 40
                                    type: array
                                    items:
                                      type: string
                                      minLength: 1
                                      maxLength: 120
                                  labels:
                                    type: object
                                    propertyNames:
                                      type: string
                                      minLength: 1
                                      maxLength: 120
                                    additionalProperties:
                                      type: string
                                      minLength: 1
                                      maxLength: 120
                                  historyFields:
                                    type: object
                                    propertyNames:
                                      type: string
                                      enum:
                                        - lastIssued
                                        - lineIssueLabel
                                        - lineIssueDate
                                        - lineIssueNotes
                                        - revisionDate
                                        - revisionLabel
                                        - revisionNote
                                        - lineRevisionLabel
                                        - lineRevisionDate
                                        - lineRevisionNotes
                                    additionalProperties:
                                      type: object
                                      properties:
                                        list:
                                          type: boolean
                                        withSibling:
                                          type: string
                                          enum:
                                            - before
                                            - after
                                      additionalProperties: false
                                  suppliers:
                                    type: object
                                    properties:
                                      show:
                                        type: string
                                        enum:
                                          - all
                                      arrange:
                                        type: string
                                        enum:
                                          - stacked
                                          - sideBySide
                                    required:
                                      - show
                                    additionalProperties: false
                                  columns:
                                    anyOf:
                                      - type: integer
                                        minimum: 1
                                        maximum: 3
                                      - type: string
                                        enum:
                                          - auto
                                  labelLayout:
                                    default: stacked
                                    type: string
                                    enum:
                                      - stacked
                                      - inline
                                  labelWidth:
                                    default: 35
                                    type: integer
                                    minimum: 5
                                    maximum: 60
                                  lineHeight:
                                    default: 1.4
                                    type: number
                                    minimum: 0.85
                                    maximum: 2.5
                                  fieldGap:
                                    default: 0.5
                                    type: number
                                    minimum: 0
                                    maximum: 4
                                  textOverflow:
                                    default: wrap
                                    type: string
                                    enum:
                                      - wrap
                                      - clip
                                  maxLines:
                                    default: 2
                                    type: integer
                                    minimum: 1
                                    maximum: 4
                                  currency:
                                    anyOf:
                                      - type: string
                                        pattern: ^[A-Z]{3}$
                                      - type: 'null'
                                  columnWidths:
                                    maxItems: 3
                                    type: array
                                    items:
                                      type: integer
                                      minimum: 5
                                      maximum: 80
                                  columnAlign:
                                    maxItems: 3
                                    type: array
                                    items:
                                      type: string
                                      enum:
                                        - left
                                        - center
                                        - right
                                  align:
                                    default: left
                                    type: string
                                    enum:
                                      - left
                                      - center
                                      - right
                                  repeatEveryPage:
                                    type: boolean
                                  productTypeFields:
                                    type: boolean
                                required:
                                  - fields
                                  - columns
                                  - labelLayout
                                  - labelWidth
                                  - lineHeight
                                  - fieldGap
                                  - textOverflow
                                  - maxLines
                                  - align
                                additionalProperties: false
                            required:
                              - id
                              - type
                              - props
                            additionalProperties: false
                          - type: object
                            properties:
                              id:
                                type: string
                                minLength: 1
                                maxLength: 120
                              type:
                                type: string
                                enum:
                                  - dataTable
                              props:
                                type: object
                                properties:
                                  labelTransform:
                                    type: string
                                    enum:
                                      - none
                                      - uppercase
                                      - title
                                      - sentence
                                      - brand
                                  source:
                                    default: components
                                    type: string
                                    enum:
                                      - components
                                      - items
                                  fields:
                                    minItems: 1
                                    maxItems: 30
                                    type: array
                                    items:
                                      type: string
                                      minLength: 1
                                      maxLength: 120
                                  showHeader:
                                    type: boolean
                                  columnWidths:
                                    default: {}
                                    type: object
                                    propertyNames:
                                      type: string
                                      minLength: 1
                                      maxLength: 120
                                    additionalProperties:
                                      type: integer
                                      minimum: 5
                                      maximum: 80
                                  textOverflow:
                                    default: wrap
                                    type: string
                                    enum:
                                      - wrap
                                      - clip
                                  maxLines:
                                    default: 2
                                    type: integer
                                    minimum: 1
                                    maximum: 4
                                  repeatEveryPage:
                                    type: boolean
                                required:
                                  - source
                                  - fields
                                  - showHeader
                                  - columnWidths
                                  - textOverflow
                                  - maxLines
                                additionalProperties: false
                            required:
                              - id
                              - type
                              - props
                            additionalProperties: false
                          - type: object
                            properties:
                              id:
                                type: string
                                minLength: 1
                                maxLength: 120
                              type:
                                type: string
                                enum:
                                  - image
                              props:
                                type: object
                                properties:
                                  source:
                                    type: string
                                    enum:
                                      - primary
                                      - secondary
                                      - next
                                      - photo
                                      - field
                                      - asset
                                  photo:
                                    anyOf:
                                      - type: integer
                                        minimum: 1
                                        maximum: 20
                                      - type: 'null'
                                  field:
                                    default: null
                                    anyOf:
                                      - type: string
                                        maxLength: 120
                                      - type: 'null'
                                  assetId:
                                    anyOf:
                                      - type: string
                                        minLength: 1
                                        maxLength: 120
                                      - type: 'null'
                                  fit:
                                    type: string
                                    enum:
                                      - contain
                                      - cover
                                  ratio:
                                    anyOf:
                                      - type: string
                                        enum:
                                          - auto
                                          - '1:1'
                                          - '4:3'
                                          - '3:2'
                                          - '16:9'
                                      - type: 'null'
                                  height:
                                    type: string
                                    enum:
                                      - sm
                                      - md
                                      - lg
                                  heightMm:
                                    anyOf:
                                      - type: number
                                        minimum: 15
                                        maximum: 250
                                      - type: 'null'
                                  align:
                                    type: string
                                    enum:
                                      - left
                                      - center
                                      - right
                                  caption:
                                    type: string
                                    maxLength: 500
                                  repeatEveryPage:
                                    type: boolean
                                required:
                                  - source
                                  - field
                                  - fit
                                  - caption
                                additionalProperties: false
                            required:
                              - id
                              - type
                              - props
                            additionalProperties: false
                          - type: object
                            properties:
                              id:
                                type: string
                                minLength: 1
                                maxLength: 120
                              type:
                                type: string
                                enum:
                                  - gallery
                              props:
                                type: object
                                properties:
                                  columns:
                                    type: integer
                                    minimum: 2
                                    maximum: 8
                                  photos:
                                    default: all
                                    type: string
                                    enum:
                                      - all
                                      - additional
                                  slots:
                                    default: []
                                    maxItems: 8
                                    type: array
                                    items:
                                      anyOf:
                                        - anyOf:
                                            - type: string
                                              minLength: 1
                                              maxLength: 120
                                            - type: object
                                              properties:
                                                photo:
                                                  type: integer
                                                  minimum: 1
                                                  maximum: 20
                                              required:
                                                - photo
                                              additionalProperties: false
                                        - type: 'null'
                                  fit:
                                    type: string
                                    enum:
                                      - contain
                                      - cover
                                  ratio:
                                    anyOf:
                                      - type: string
                                        enum:
                                          - auto
                                          - '1:1'
                                          - '4:3'
                                          - '3:2'
                                          - '16:9'
                                      - type: 'null'
                                  heightMm:
                                    anyOf:
                                      - type: number
                                        minimum: 15
                                        maximum: 250
                                      - type: 'null'
                                  repeatEveryPage:
                                    type: boolean
                                required:
                                  - columns
                                  - photos
                                  - slots
                                  - fit
                                additionalProperties: false
                            required:
                              - id
                              - type
                              - props
                            additionalProperties: false
                          - type: object
                            properties:
                              id:
                                type: string
                                minLength: 1
                                maxLength: 120
                              type:
                                type: string
                                enum:
                                  - imageFields
                              props:
                                type: object
                                properties:
                                  labelTransform:
                                    type: string
                                    enum:
                                      - none
                                      - uppercase
                                      - title
                                      - sentence
                                      - brand
                                  fields:
                                    maxItems: 20
                                    type: array
                                    items:
                                      type: string
                                      minLength: 1
                                      maxLength: 120
                                  labels:
                                    type: object
                                    propertyNames:
                                      type: string
                                      minLength: 1
                                      maxLength: 120
                                    additionalProperties:
                                      type: string
                                      minLength: 1
                                      maxLength: 120
                                  historyFields:
                                    type: object
                                    propertyNames:
                                      type: string
                                      enum:
                                        - lastIssued
                                        - lineIssueLabel
                                        - lineIssueDate
                                        - lineIssueNotes
                                        - revisionDate
                                        - revisionLabel
                                        - revisionNote
                                        - lineRevisionLabel
                                        - lineRevisionDate
                                        - lineRevisionNotes
                                    additionalProperties:
                                      type: object
                                      properties:
                                        list:
                                          type: boolean
                                        withSibling:
                                          type: string
                                          enum:
                                            - before
                                            - after
                                      additionalProperties: false
                                  suppliers:
                                    type: object
                                    properties:
                                      show:
                                        type: string
                                        enum:
                                          - all
                                      arrange:
                                        type: string
                                        enum:
                                          - stacked
                                          - sideBySide
                                    required:
                                      - show
                                    additionalProperties: false
                                  imageField:
                                    default: null
                                    anyOf:
                                      - type: string
                                        minLength: 1
                                        maxLength: 120
                                      - type: 'null'
                                  imagePosition:
                                    type: string
                                    enum:
                                      - left
                                      - right
                                      - top
                                  fit:
                                    type: string
                                    enum:
                                      - contain
                                      - cover
                                  ratio:
                                    anyOf:
                                      - type: string
                                        enum:
                                          - auto
                                          - '1:1'
                                          - '4:3'
                                          - '3:2'
                                          - '16:9'
                                      - type: 'null'
                                  height:
                                    type: string
                                    enum:
                                      - sm
                                      - md
                                      - lg
                                  heightMm:
                                    anyOf:
                                      - type: number
                                        minimum: 15
                                        maximum: 250
                                      - type: 'null'
                                  textOverflow:
                                    default: wrap
                                    type: string
                                    enum:
                                      - wrap
                                      - clip
                                  maxLines:
                                    default: 2
                                    type: integer
                                    minimum: 1
                                    maximum: 4
                                  labelLayout:
                                    type: string
                                    enum:
                                      - stacked
                                      - inline
                                  labelWidth:
                                    type: integer
                                    minimum: 5
                                    maximum: 60
                                  caption:
                                    type: string
                                    maxLength: 200
                                  currency:
                                    anyOf:
                                      - type: string
                                        pattern: ^[A-Z]{3}$
                                      - type: 'null'
                                  repeatEveryPage:
                                    type: boolean
                                  productTypeFields:
                                    type: boolean
                                required:
                                  - fields
                                  - imageField
                                  - imagePosition
                                  - textOverflow
                                  - maxLines
                                additionalProperties: false
                            required:
                              - id
                              - type
                              - props
                            additionalProperties: false
                          - type: object
                            properties:
                              id:
                                type: string
                                minLength: 1
                                maxLength: 120
                              type:
                                type: string
                                enum:
                                  - logo
                              props:
                                type: object
                                properties:
                                  slot:
                                    type: string
                                    enum:
                                      - primary
                                      - secondary
                                      - footer
                                  align:
                                    type: string
                                    enum:
                                      - left
                                      - center
                                      - right
                                  repeatEveryPage:
                                    type: boolean
                                required:
                                  - slot
                                additionalProperties: false
                            required:
                              - id
                              - type
                              - props
                            additionalProperties: false
                          - type: object
                            properties:
                              id:
                                type: string
                                minLength: 1
                                maxLength: 120
                              type:
                                type: string
                                enum:
                                  - divider
                              props:
                                type: object
                                properties:
                                  tone:
                                    type: string
                                    enum:
                                      - primary
                                      - secondary
                                      - muted
                                  lineStyle:
                                    type: string
                                    enum:
                                      - solid
                                      - dashed
                                      - dotted
                                  repeatEveryPage:
                                    type: boolean
                                required:
                                  - tone
                                additionalProperties: false
                            required:
                              - id
                              - type
                              - props
                            additionalProperties: false
                          - type: object
                            properties:
                              id:
                                type: string
                                minLength: 1
                                maxLength: 120
                              type:
                                type: string
                                enum:
                                  - qrCode
                              props:
                                type: object
                                properties:
                                  value:
                                    type: string
                                    maxLength: 1000
                                  size:
                                    default: 24
                                    type: integer
                                    minimum: 12
                                    maximum: 60
                                  align:
                                    default: left
                                    type: string
                                    enum:
                                      - left
                                      - center
                                      - right
                                  repeatEveryPage:
                                    type: boolean
                                required:
                                  - value
                                  - size
                                  - align
                                additionalProperties: false
                            required:
                              - id
                              - type
                              - props
                            additionalProperties: false
                          - type: object
                            properties:
                              id:
                                type: string
                                minLength: 1
                                maxLength: 120
                              type:
                                type: string
                                enum:
                                  - spacer
                              props:
                                type: object
                                properties:
                                  size:
                                    type: string
                                    enum:
                                      - sm
                                      - md
                                      - lg
                                      - xl
                                  repeatEveryPage:
                                    type: boolean
                                required:
                                  - size
                                additionalProperties: false
                            required:
                              - id
                              - type
                              - props
                            additionalProperties: false
                          - type: object
                            properties:
                              id:
                                type: string
                                minLength: 1
                                maxLength: 120
                              type:
                                type: string
                                enum:
                                  - guidance
                              props:
                                type: object
                                properties:
                                  source:
                                    type: string
                                    enum:
                                      - instructions
                                      - requirements
                                      - furnishedInstalledBy
                                  showGroupLabels:
                                    default: true
                                    type: boolean
                                  display:
                                    type: string
                                    enum:
                                      - checklist
                                  columns:
                                    type: integer
                                    minimum: 1
                                    maximum: 4
                                  repeatEveryPage:
                                    type: boolean
                                required:
                                  - source
                                  - showGroupLabels
                                additionalProperties: false
                            required:
                              - id
                              - type
                              - props
                            additionalProperties: false
                          - type: object
                            properties:
                              id:
                                type: string
                                minLength: 1
                                maxLength: 120
                              type:
                                type: string
                                enum:
                                  - areas
                              props:
                                type: object
                                properties:
                                  labelTransform:
                                    type: string
                                    enum:
                                      - none
                                      - uppercase
                                      - title
                                      - sentence
                                      - brand
                                  columns:
                                    default: 4
                                    type: integer
                                    minimum: 1
                                    maximum: 4
                                  showRoomNumbers:
                                    default: false
                                    type: boolean
                                  roomTotals:
                                    type: boolean
                                  repeatEveryPage:
                                    type: boolean
                                required:
                                  - columns
                                  - showRoomNumbers
                                additionalProperties: false
                            required:
                              - id
                              - type
                              - props
                            additionalProperties: false
                          - type: object
                            properties:
                              id:
                                type: string
                                minLength: 1
                                maxLength: 120
                              type:
                                type: string
                                enum:
                                  - schedule
                              props:
                                type: object
                                properties:
                                  groupBy:
                                    type: string
                                    enum:
                                      - none
                                      - category
                                      - area
                                      - areaTree
                                      - manufacturer
                                      - supplier
                                      - department
                                  showSubtotals:
                                    type: boolean
                                  dedupCategory:
                                    type: boolean
                                  subcategoryAsSubtitle:
                                    type: boolean
                                  showGrandTotal:
                                    type: boolean
                                  headerBold:
                                    type: boolean
                                  columnAlign:
                                    type: object
                                    propertyNames:
                                      type: string
                                      minLength: 1
                                      maxLength: 120
                                    additionalProperties:
                                      type: string
                                      enum:
                                        - left
                                        - center
                                        - right
                                  textOverflow:
                                    type: string
                                    enum:
                                      - wrap
                                      - clip
                                  maxLines:
                                    type: integer
                                    minimum: 1
                                    maximum: 4
                                  showRoomNumbers:
                                    default: false
                                    type: boolean
                                  roomColumns:
                                    default: 4
                                    type: integer
                                    minimum: 1
                                    maximum: 4
                                  quantityBreakdown:
                                    default: false
                                    type: boolean
                                  bandDetails:
                                    default: none
                                    type: string
                                    enum:
                                      - none
                                      - company
                                  roomTotals:
                                    default: false
                                    type: boolean
                                  currency:
                                    default: null
                                    anyOf:
                                      - type: string
                                        pattern: ^[A-Z]{3}$
                                      - type: 'null'
                                  labelTransform:
                                    type: string
                                    enum:
                                      - none
                                      - uppercase
                                      - title
                                      - sentence
                                      - brand
                                  columns:
                                    minItems: 1
                                    maxItems: 30
                                    type: array
                                    items:
                                      type: object
                                      properties:
                                        key:
                                          type: string
                                          minLength: 1
                                          maxLength: 120
                                        label:
                                          type: string
                                          minLength: 1
                                          maxLength: 120
                                        width:
                                          anyOf:
                                            - type: integer
                                              minimum: 5
                                              maximum: 80
                                            - type: 'null'
                                      required:
                                        - key
                                        - label
                                        - width
                                      additionalProperties: false
                                  suppliers:
                                    type: object
                                    properties:
                                      show:
                                        type: string
                                        enum:
                                          - all
                                    required:
                                      - show
                                    additionalProperties: false
                                required:
                                  - groupBy
                                  - showSubtotals
                                  - dedupCategory
                                  - subcategoryAsSubtitle
                                  - showGrandTotal
                                  - headerBold
                                  - columnAlign
                                  - textOverflow
                                  - maxLines
                                  - showRoomNumbers
                                  - roomColumns
                                  - quantityBreakdown
                                  - bandDetails
                                  - roomTotals
                                  - currency
                                  - columns
                                additionalProperties: false
                            required:
                              - id
                              - type
                              - props
                            additionalProperties: false
                          - type: object
                            properties:
                              id:
                                type: string
                                minLength: 1
                                maxLength: 120
                              type:
                                type: string
                                enum:
                                  - itemsGrid
                              props:
                                type: object
                                properties:
                                  columns:
                                    type: integer
                                    minimum: 1
                                    maximum: 4
                                  itemsPerPage:
                                    type: integer
                                    minimum: 1
                                    maximum: 12
                                  groupBy:
                                    default: none
                                    type: string
                                    enum:
                                      - none
                                      - category
                                      - area
                                  cardPer:
                                    default: item
                                    type: string
                                    enum:
                                      - item
                                      - unit
                                  cardBackground:
                                    default: '#FFFFFF'
                                    anyOf:
                                      - type: string
                                        enum:
                                          - none
                                          - primary
                                          - secondary
                                      - type: string
                                        pattern: ^#[0-9A-F]{6}$
                                  card:
                                    minItems: 1
                                    maxItems: 8
                                    type: array
                                    items:
                                      anyOf:
                                        - oneOf:
                                            - type: object
                                              properties:
                                                id:
                                                  type: string
                                                  minLength: 1
                                                  maxLength: 120
                                                type:
                                                  type: string
                                                  enum:
                                                    - heading
                                                props:
                                                  type: object
                                                  properties:
                                                    text:
                                                      type: string
                                                      maxLength: 500
                                                    level:
                                                      type: string
                                                      enum:
                                                        - '1'
                                                        - '2'
                                                        - '3'
                                                    align:
                                                      type: string
                                                      enum:
                                                        - left
                                                        - center
                                                        - right
                                                    size:
                                                      default: null
                                                      anyOf:
                                                        - type: number
                                                          minimum: 0.5
                                                          maximum: 3
                                                        - type: 'null'
                                                    weight:
                                                      default: null
                                                      anyOf:
                                                        - type: string
                                                          enum:
                                                            - regular
                                                            - medium
                                                            - bold
                                                        - type: 'null'
                                                    textTransform:
                                                      type: string
                                                      enum:
                                                        - none
                                                        - uppercase
                                                        - title
                                                        - sentence
                                                        - brand
                                                    background:
                                                      anyOf:
                                                        - type: string
                                                          enum:
                                                            - none
                                                            - primary
                                                            - secondary
                                                        - type: string
                                                          pattern: ^#[0-9A-F]{6}$
                                                    repeatEveryPage:
                                                      type: boolean
                                                    repeatWhileSectionContinues:
                                                      type: boolean
                                                  required:
                                                    - text
                                                    - level
                                                    - align
                                                    - size
                                                    - weight
                                                  additionalProperties: false
                                              required:
                                                - id
                                                - type
                                                - props
                                              additionalProperties: false
                                            - type: object
                                              properties:
                                                id:
                                                  type: string
                                                  minLength: 1
                                                  maxLength: 120
                                                type:
                                                  type: string
                                                  enum:
                                                    - text
                                                props:
                                                  type: object
                                                  properties:
                                                    text:
                                                      type: string
                                                      maxLength: 8000
                                                    align:
                                                      default: left
                                                      type: string
                                                      enum:
                                                        - left
                                                        - center
                                                        - right
                                                    size:
                                                      default: null
                                                      anyOf:
                                                        - type: number
                                                          minimum: 0.5
                                                          maximum: 3
                                                        - type: 'null'
                                                    weight:
                                                      default: null
                                                      anyOf:
                                                        - type: string
                                                          enum:
                                                            - regular
                                                            - medium
                                                            - bold
                                                        - type: 'null'
                                                    textTransform:
                                                      type: string
                                                      enum:
                                                        - none
                                                        - uppercase
                                                        - title
                                                        - sentence
                                                        - brand
                                                    background:
                                                      anyOf:
                                                        - type: string
                                                          enum:
                                                            - none
                                                            - primary
                                                            - secondary
                                                        - type: string
                                                          pattern: ^#[0-9A-F]{6}$
                                                    repeatEveryPage:
                                                      type: boolean
                                                  required:
                                                    - text
                                                    - align
                                                    - size
                                                    - weight
                                                  additionalProperties: false
                                              required:
                                                - id
                                                - type
                                                - props
                                              additionalProperties: false
                                            - type: object
                                              properties:
                                                id:
                                                  type: string
                                                  minLength: 1
                                                  maxLength: 120
                                                type:
                                                  type: string
                                                  enum:
                                                    - fieldList
                                                props:
                                                  type: object
                                                  properties:
                                                    labelTransform:
                                                      type: string
                                                      enum:
                                                        - none
                                                        - uppercase
                                                        - title
                                                        - sentence
                                                        - brand
                                                    fields:
                                                      maxItems: 40
                                                      type: array
                                                      items:
                                                        type: string
                                                        minLength: 1
                                                        maxLength: 120
                                                    labels:
                                                      type: object
                                                      propertyNames:
                                                        type: string
                                                        minLength: 1
                                                        maxLength: 120
                                                      additionalProperties:
                                                        type: string
                                                        minLength: 1
                                                        maxLength: 120
                                                    historyFields:
                                                      type: object
                                                      propertyNames:
                                                        type: string
                                                        enum:
                                                          - lastIssued
                                                          - lineIssueLabel
                                                          - lineIssueDate
                                                          - lineIssueNotes
                                                          - revisionDate
                                                          - revisionLabel
                                                          - revisionNote
                                                          - lineRevisionLabel
                                                          - lineRevisionDate
                                                          - lineRevisionNotes
                                                      additionalProperties:
                                                        type: object
                                                        properties:
                                                          list:
                                                            type: boolean
                                                          withSibling:
                                                            type: string
                                                            enum:
                                                              - before
                                                              - after
                                                        additionalProperties: false
                                                    suppliers:
                                                      type: object
                                                      properties:
                                                        show:
                                                          type: string
                                                          enum:
                                                            - all
                                                        arrange:
                                                          type: string
                                                          enum:
                                                            - stacked
                                                            - sideBySide
                                                      required:
                                                        - show
                                                      additionalProperties: false
                                                    columns:
                                                      anyOf:
                                                        - type: integer
                                                          minimum: 1
                                                          maximum: 3
                                                        - type: string
                                                          enum:
                                                            - auto
                                                    labelLayout:
                                                      default: stacked
                                                      type: string
                                                      enum:
                                                        - stacked
                                                        - inline
                                                    labelWidth:
                                                      default: 35
                                                      type: integer
                                                      minimum: 5
                                                      maximum: 60
                                                    lineHeight:
                                                      default: 1.4
                                                      type: number
                                                      minimum: 0.85
                                                      maximum: 2.5
                                                    fieldGap:
                                                      default: 0.5
                                                      type: number
                                                      minimum: 0
                                                      maximum: 4
                                                    textOverflow:
                                                      default: wrap
                                                      type: string
                                                      enum:
                                                        - wrap
                                                        - clip
                                                    maxLines:
                                                      default: 2
                                                      type: integer
                                                      minimum: 1
                                                      maximum: 4
                                                    currency:
                                                      anyOf:
                                                        - type: string
                                                          pattern: ^[A-Z]{3}$
                                                        - type: 'null'
                                                    columnWidths:
                                                      maxItems: 3
                                                      type: array
                                                      items:
                                                        type: integer
                                                        minimum: 5
                                                        maximum: 80
                                                    columnAlign:
                                                      maxItems: 3
                                                      type: array
                                                      items:
                                                        type: string
                                                        enum:
                                                          - left
                                                          - center
                                                          - right
                                                    align:
                                                      default: left
                                                      type: string
                                                      enum:
                                                        - left
                                                        - center
                                                        - right
                                                    repeatEveryPage:
                                                      type: boolean
                                                    productTypeFields:
                                                      type: boolean
                                                  required:
                                                    - fields
                                                    - columns
                                                    - labelLayout
                                                    - labelWidth
                                                    - lineHeight
                                                    - fieldGap
                                                    - textOverflow
                                                    - maxLines
                                                    - align
                                                  additionalProperties: false
                                              required:
                                                - id
                                                - type
                                                - props
                                              additionalProperties: false
                                            - type: object
                                              properties:
                                                id:
                                                  type: string
                                                  minLength: 1
                                                  maxLength: 120
                                                type:
                                                  type: string
                                                  enum:
                                                    - dataTable
                                                props:
                                                  type: object
                                                  properties:
                                                    labelTransform:
                                                      type: string
                                                      enum:
                                                        - none
                                                        - uppercase
                                                        - title
                                                        - sentence
                                                        - brand
                                                    source:
                                                      default: components
                                                      type: string
                                                      enum:
                                                        - components
                                                        - items
                                                    fields:
                                                      minItems: 1
                                                      maxItems: 30
                                                      type: array
                                                      items:
                                                        type: string
                                                        minLength: 1
                                                        maxLength: 120
                                                    showHeader:
                                                      type: boolean
                                                    columnWidths:
                                                      default: {}
                                                      type: object
                                                      propertyNames:
                                                        type: string
                                                        minLength: 1
                                                        maxLength: 120
                                                      additionalProperties:
                                                        type: integer
                                                        minimum: 5
                                                        maximum: 80
                                                    textOverflow:
                                                      default: wrap
                                                      type: string
                                                      enum:
                                                        - wrap
                                                        - clip
                                                    maxLines:
                                                      default: 2
                                                      type: integer
                                                      minimum: 1
                                                      maximum: 4
                                                    repeatEveryPage:
                                                      type: boolean
                                                  required:
                                                    - source
                                                    - fields
                                                    - showHeader
                                                    - columnWidths
                                                    - textOverflow
                                                    - maxLines
                                                  additionalProperties: false
                                              required:
                                                - id
                                                - type
                                                - props
                                              additionalProperties: false
                                            - type: object
                                              properties:
                                                id:
                                                  type: string
                                                  minLength: 1
                                                  maxLength: 120
                                                type:
                                                  type: string
                                                  enum:
                                                    - image
                                                props:
                                                  type: object
                                                  properties:
                                                    source:
                                                      type: string
                                                      enum:
                                                        - primary
                                                        - secondary
                                                        - next
                                                        - photo
                                                        - field
                                                        - asset
                                                    photo:
                                                      anyOf:
                                                        - type: integer
                                                          minimum: 1
                                                          maximum: 20
                                                        - type: 'null'
                                                    field:
                                                      default: null
                                                      anyOf:
                                                        - type: string
                                                          maxLength: 120
                                                        - type: 'null'
                                                    assetId:
                                                      anyOf:
                                                        - type: string
                                                          minLength: 1
                                                          maxLength: 120
                                                        - type: 'null'
                                                    fit:
                                                      type: string
                                                      enum:
                                                        - contain
                                                        - cover
                                                    ratio:
                                                      anyOf:
                                                        - type: string
                                                          enum:
                                                            - auto
                                                            - '1:1'
                                                            - '4:3'
                                                            - '3:2'
                                                            - '16:9'
                                                        - type: 'null'
                                                    height:
                                                      type: string
                                                      enum:
                                                        - sm
                                                        - md
                                                        - lg
                                                    heightMm:
                                                      anyOf:
                                                        - type: number
                                                          minimum: 15
                                                          maximum: 250
                                                        - type: 'null'
                                                    align:
                                                      type: string
                                                      enum:
                                                        - left
                                                        - center
                                                        - right
                                                    caption:
                                                      type: string
                                                      maxLength: 500
                                                    repeatEveryPage:
                                                      type: boolean
                                                  required:
                                                    - source
                                                    - field
                                                    - fit
                                                    - caption
                                                  additionalProperties: false
                                              required:
                                                - id
                                                - type
                                                - props
                                              additionalProperties: false
                                            - type: object
                                              properties:
                                                id:
                                                  type: string
                                                  minLength: 1
                                                  maxLength: 120
                                                type:
                                                  type: string
                                                  enum:
                                                    - gallery
                                                props:
                                                  type: object
                                                  properties:
                                                    columns:
                                                      type: integer
                                                      minimum: 2
                                                      maximum: 8
                                                    photos:
                                                      default: all
                                                      type: string
                                                      enum:
                                                        - all
                                                        - additional
                                                    slots:
                                                      default: []
                                                      maxItems: 8
                                                      type: array
                                                      items:
                                                        anyOf:
                                                          - anyOf:
                                                              - type: string
                                                                minLength: 1
                                                                maxLength: 120
                                                              - type: object
                                                                properties:
                                                                  photo:
                                                                    type: integer
                                                                    minimum: 1
                                                                    maximum: 20
                                                                required:
                                                                  - photo
                                                                additionalProperties: false
                                                          - type: 'null'
                                                    fit:
                                                      type: string
                                                      enum:
                                                        - contain
                                                        - cover
                                                    ratio:
                                                      anyOf:
                                                        - type: string
                                                          enum:
                                                            - auto
                                                            - '1:1'
                                                            - '4:3'
                                                            - '3:2'
                                                            - '16:9'
                                                        - type: 'null'
                                                    heightMm:
                                                      anyOf:
                                                        - type: number
                                                          minimum: 15
                                                          maximum: 250
                                                        - type: 'null'
                                                    repeatEveryPage:
                                                      type: boolean
                                                  required:
                                                    - columns
                                                    - photos
                                                    - slots
                                                    - fit
                                                  additionalProperties: false
                                              required:
                                                - id
                                                - type
                                                - props
                                              additionalProperties: false
                                            - type: object
                                              properties:
                                                id:
                                                  type: string
                                                  minLength: 1
                                                  maxLength: 120
                                                type:
                                                  type: string
                                                  enum:
                                                    - imageFields
                                                props:
                                                  type: object
                                                  properties:
                                                    labelTransform:
[...]
